<?php 
/* 
Plugin Name: Landing sites (de) 
Plugin URI: http://bueltge.de/wp-landingsites-de-plugin/181/ 
Description: Wennn Besucher von einer Suchmaschine auf deine Seite kommen, suchen sie spezifisch nach etwas. Meist durchsuchen sie nur das Suchergebnis. Mit diesem Plugin wird dem Besucher einer Auswahl an relevanten Artikeln deiner Seite angeboten. 
Version: 2.2 de 
Author: <a href="http://theundersigned.net/">The undersigned</a> and <a href="http://bueltge.de">Frank Bueltge</a>,modified by <a href="http://www.juyimeng.com">phpbird</a>
*/ 

/* 
-------------------------------------------------------------------------------- 

DANKSAGUNGEN: 
Dieses Plugin entstand mit Hilfe der Scripte: 
http://www.w-a-s-a-b-i.com/archives/2006/02/02/wordpress-related-entries-20/ 
http://textsnippets.com/posts/show/231 
http://www.lazaryn.com/entry-28.html 
-------------------------------------------------------------------------------- 

INSTALLATION: 
0. OPTIONAL: veraendere den Text in Zeile 50 

1. Kopiere die Datei in dein Plugin-Verzeichnis (wp-content/plugins) 

2. Fuer die Darstellung der aehnlichen Beitraege nutze folgenden Code und integriere ihn in dein Template. 
   (Optional: F��r die Ausgabe kann auch jede andere Funktion von Plugins genutzt werden, einfach ls_related() mit deiner Funktion ersetzen.) 
    <?php if (function_exists('ls_getinfo')) : ?> 
        <?php if (ls_getinfo('isref')) { ?> 
            <div class="landingsites"> 
                <h2>Ihre Suche nach: <?php ls_getinfo('terms'); ?></h2> 
                <p>Sie kommen von <?php ls_getinfo('referrer'); ?> und suchen nach <em><?php ls_getinfo('terms'); ?></em>. Folgende Beitr&auml;ge k&ouml;nnten von Interesse f&uuml;r sie sein:</p> 
                <ul> 
                <?php ls_related(5, 10, '<li>', '</li>', '', '', false, false); ?> 
                </ul> 
            </div> 
        <?php } ?> 
    <?php endif; ?> 
     
3. Nun das Plugin in der Admin-Oberflaeche aktivieren. 

-------------------------------------------------------------------------------- 

KONFIGURATION: 
Hier kann der Text veraendert werden, der angezeigt wird, wenn keine aehnlichen Beitraege vorliegen. 
*/ 
$fb_noposts = ''; 



function ls_get_delim($ref) { 
    $search_engines = array( 
            'google.com' => 'q', 
            'google.de' => 'q', 
            'google.it' => 'q', 
            'google.be' => 'q', 
            'google.at' => 'q', 
            'google.ch' => 'q', 
            'google.nl' => 'q', 
            'go.google.com' => 'q', 
            'maps.google.com' => 'q', 
            'local.google.com' => 'q', 
            'search.yahoo.com' => 'p', 
            'fr.search.yahoo.com' => 'p', 
            'search.msn.com' => 'q', 
            'msxml.excite.com' => 'qkw', 
            'search.lycos.com' => 'query', 
            'alltheweb.com' => 'q', 
            'search.aol.com' => 'query', 
            'search.iwon.com' => 'searchfor', 
            'ask.com' => 'q', 
            'de.ask.com' => 'q', 
            'ask.co.uk' => 'ask', 
            'search.cometsystems.com' => 'qry', 
            'hotbot.com' => 'query', 
            'overture.com' => 'Keywords', 
            'metacrawler.com' => 'qkw', 
            'search.netscape.com' => 'query', 
            'looksmart.com' => 'key', 
            'dpxml.webcrawler.com' => 'qkw', 
            'search.earthlink.net' => 'q', 
            'search.viewpoint.com' => 'k', 
            'mamma.com' => 'query', 
            'suche.t-online.de' => 'q', 
            'de.altavista.com' => 'q', 
            'fireball.de' => 'q', 
            'freenet.de' => 'q', 
            'suche.freenet.de' => 'query', 
            'dmoz.de' => 'q', 
            'fastbot.de' => 'q', 
            'allesklar.de' => 'q', 
            'web.de' => 'q', 
            'infoseeker.de' => 'q', 
            'hotbot.de' => 'q', 
            'blogsearch.google.com' => 'q', 
            'blogsearch.google.de' => 'q', 
            'blogsearch.google.ch' => 'q', 
            'blogsearch.google.at' => 'q', 
            'search.blogger.com' => 'q', 
            'de.search.yahoo.com' => 'p', 
            'ch.search.yahoo.com' => 'p', 
            'at.search.yahoo.com' => 'p', 
            'suche.lycos.de' => 'query', 
            'search.lycos.ch' => 'query', 
            'suche.lycos.at' => 'query', 
            'suche.aol.de' => 'q', 
            'suche.aolsvc.de' => 'q', 
            'sucheaol.aol.de' => 'query', 
            'search.ch' => 'q', 
            'bluewin.ch' => 'q', 
            'eu.ixquick.com��' => 'query', 
            'clusty.com' => 'query', 
            'partner.exalead.com' => 'q', 
            'search.abacho.com' => 'q', 
            'mserv.rrzn.uni-hannover.de' => 'eingabe', 
            'gmx.net' => 'search', 
            'search.seznam.cz' => 'w', 
            'startgoogle.startpagina.nl' => 'q', 
            'search.platformaonline.com' => 'q', 
            'hispeed.ch' => 'q', 
            'answers.com' => 's', 
            'metager1.de' => 'q', 
						'baidu.com' => 'wd',
						'soso.com'  => 'w',
						'sogou.com'  => 'query',
						'cha.so.163.com'  => 'q',
						'page.so.163.com'  => 'q',
						'site.so.163.com'  => 'q',
						'news.so.163.com'  => 'q',
						'pic.so.163.com'  => 'q',
						'search.live.com' => 'q',
            'metager2.de' => 'q'); 

    $delim = false; 

    // Check to see if we have a host match in our lookup array 
    if (isset($search_engines[$ref])) { 
        $delim = $search_engines[$ref]; 
    } else { 
        // Lets check for referrals for international TLDs and sites with strange formats 

        // Optimizations 
        $sub13 = substr($ref, 0, 13); 

        // Search string for engine 
        if(substr($ref, 0, 7) == 'google.') 
            $delim = "q"; 
        elseif($sub13 == 'search.atomz.') 
            $delim = "sp-q"; 
        elseif(substr($ref, 0, 11) == 'search.msn.') 
            $delim = "q"; 
        elseif($sub13 == 'search.yahoo.') 
            $delim = "p"; 
        elseif(preg_match('/home\.bellsouth\.net\/s\/s\.dll/i', $ref)) 
            $delim = "bellsouth"; 
    } 

    return $delim; 
} 

function ls_get_terms($d) { 
    $terms       = null; 
    $query_array = array(); 
    $query_terms = null; 
//$encoding_list="EUC-CN, UTF-8";
    // Get raw query 
    //$query = explode($d.'=', $_SERVER['HTTP_REFERER']); 
    $query = explode('&'.$d.'=', $_SERVER['HTTP_REFERER']); 
    if($query[1] == '') { 
        $query = explode('?'.$d.'=', $_SERVER['HTTP_REFERER']); 
    } 
    $query = explode('&', $query[1]); 
    $query = urldecode($query[0]); 

    // Remove quotes, split into words, and format for HTML display 
    $query = str_replace("'", '', $query); 
    $query = str_replace('"', '', $query); 
    $query_array = preg_split('/[\s,\+\.]+/',$query); 
    $query_terms = implode(' ', $query_array); 
    $terms = htmlspecialchars(urldecode($query_terms)); 
	//convert gbk->utf8 if terms is not utf8
	if (!seems_utf8($terms)){
		$terms=iconv("GBK", "UTF-8", $terms);
	}
    return $terms; 
} 

function ls_get_refer() { 
    // Break out quickly so we don't waste CPU cycles on non referrals 
    if (!isset($_SERVER['HTTP_REFERER']) || ($_SERVER['HTTP_REFERER'] == '')) return false; 

    $referer_info = parse_url($_SERVER['HTTP_REFERER']); 
    $referer = $referer_info['host']; 

    // Remove www. is it exists 
    if(substr($referer, 0, 4) == 'www.') 
        $referer = substr($referer, 4); 

    return $referer; 
} 

function ls_related($limit=5, $len=10, $before_title = '', $after_title = '', $before_post = '', $after_post = '', $show_pass_post = false, $show_excerpt = false) { 
    
    global $wpdb, $id, $fb_noposts; 

    // Did we come from a search engine?  
    $referer = ls_get_refer(); 
    if (!$referer) return false; 

    $delimiter = ls_get_delim($referer); 

    if($delimiter)  
    {  
        $terms = ls_get_terms($delimiter); 

        $time_difference = get_settings('gmt_offset'); 
        $now = gmdate("Y-m-d H:i:s",(time()+($time_difference*3600))); 

        // Primary SQL query 
        /*
        $sql = "SELECT ID, post_title, post_content," 
             . "MATCH (post_name, post_content) " 
             . "AGAINST ('$terms') AS score " 
             . "FROM $wpdb->posts WHERE " 
             . "MATCH (post_name, post_content) " 
             . "AGAINST ('$terms') " 
             . "AND post_date <= '$now' " 
             . "AND (post_status IN ( 'publish',  'static' )) "; 
				             
        if ($show_pass_post=='false') { $sql .= "AND post_password ='' "; } 
        $sql .= "ORDER BY score DESC LIMIT $limit"; 
        */
//        SELECT ID, post_title, post_content,MATCH (post_name, post_content) AGAINST ('����') AS score FROM wp_posts WHERE post_date <= '2007-03-31 22:45:40' AND (post_status IN ( 'publish', 'static' )) ORDER by rand() LIMIT 5
        $sql = "SELECT ID, post_title, post_content," 
             . "MATCH (post_name, post_content) " 
             . "AGAINST ('$terms') AS score " 
             . "FROM $wpdb->posts WHERE " 
             . " post_date <= '$now' " 
             . "AND (post_status IN ( 'publish',  'static' )) "; 
				             
        if ($show_pass_post=='false') { $sql .= "AND post_password ='' "; } 
        $sql .= "ORDER BY rand() LIMIT $limit"; 

        $results = $wpdb->get_results($sql); 
        $output = ''; 
        if ($results) { 
            foreach ($results as $result) { 
                $title = stripslashes(apply_filters('the_title', $result->post_title)); 
                $permalink = get_permalink($result->ID); 
                $post_content = strip_tags($result->post_content); 
                $post_content = stripslashes($post_content); 
                $output .= $before_title .'<a href="'. $permalink .'" rel="bookmark" title="Permanent Link: ' . $title . '">' . $title . '</a>' . $after_title; 
                if ($show_excerpt=='true') { 
                    $words=split(" ",$post_content);  
                    $post_strip = join(" ", array_slice($words,0,$len)); 
                    $output .= $before_post . $post_strip . $after_post; 
                } 
            } 
            echo $output; 
        } else { 
            echo $before_title . $fb_noposts . $after_title; 
        } 
    } 
} 

// Return true if the referer is a search engine 
function ls_getinfo($what) { 

    // Did we come from a search engine?  
    $referer = ls_get_refer(); 
    if (!$referer) return false; 
    $delimiter = ls_get_delim($referer); 

    if($delimiter)  
    {  
        $terms = ls_get_terms($delimiter); 

        if($what == 'isref') { 
            return true; 
        } 
        if($what == 'referrer') { 
            $parsed = parse_url($_SERVER['HTTP_REFERER']); 
            echo '<a href="http://'.$parsed['host'].'" title="'.$parsed['host'].'">'.$parsed['host'].'</a>'; 
        } 
        if($what == 'terms') { 
            if (get_bloginfo('charset') != 'UTF-8') { 
                echo htmlentities($terms, ENT_QUOTES, 'UTF-8'); 
            } else { 
                echo $terms; 
            } 
        } 
    }  
}  

// Start Installscript 
function ls_install() { 
    global $wpdb; 
     
    $sql = 'ALTER TABLE `' . $wpdb->prefix . 'posts` ADD FULLTEXT `post_related` ( `post_name` ,' . ' `post_content` )'; 
    $wpdb->hide_errors(); 
    $sql_result = $wpdb->query($sql); 
    $wpdb->show_errors(); 
} 

function ls_set_header() { 
    if (ls_getinfo('isref')) header('Vary: Referer', FALSE); 
} 

if(function_exists('add_action')) { 
    if (isset($_GET['activate']) && $_GET['activate'] == 'true') { 
        add_action('init', 'ls_install'); 
    } 
    add_action('init', 'ls_set_header'); 
    add_filter('the_content', 'ls_terms_filter');
		add_filter('comment_text', 'ls_terms_filter');

} 
function ls_terms_filter($content){
    // Did we come from a search engine? 
    $referer = ls_get_refer();//取来源域名
    $output = '';
    $delimiter = ls_get_delim($referer);//看是否在list里面
    if($delimiter) 
    {
        $terms = ls_get_terms($delimiter);//取关键字串
				$terms= array_unique(preg_split("/[\s,]+/",  $terms));//转换为数组
				$contentarr = preg_split("/(<.*>)/U", $content, -1, PREG_SPLIT_DELIM_CAPTURE); // capture the tags as well as in between
				$stop = count($contentarr);// loop stuff 
				for ($i = 0; $i < $stop; $i++) {
					$content = $contentarr[$i]; 
					if ((strlen($content) > 0) && ('<' != $content{0})) { // If it's not a tag
						foreach ($terms as $term) {
							if (strlen($term)>1)//避免关键字太短的情况
							$content=eregi_replace("($term)","<b>\\1</b>", $content);
						} 
					} 
					$output .= $content; 
				}
 		 	return $output;
    } else{
    	return $content;
    }
}
?>
